(*---------- ISRAEL LOZANO REY      1 B - SISTEMAS ----------*)
IMPLEMENTATION MODULE Cola;
FROM Storage IMPORT ALLOCATE, DEALLOCATE, Available;
FROM cadenas IMPORT cadena;
FROM paciente IMPORT TPaciente, Gravedad;
TYPE
   TipoCola = POINTER TO Nodo;
   Nodo = RECORD
   	  pac : TPaciente;
   	  sig : TipoCola;
   	END;

PROCEDURE CrearCola(VAR c: TipoCola; VAR error: ERROR);
BEGIN
    c:= NIL;
    error:= SinError;
END CrearCola;
(*--------------------------------------------------------------*)
PROCEDURE ColaVacia(c: TipoCola; VAR error: ERROR): BOOLEAN;
BEGIN
    error:= SinError;
    RETURN (c=NIL)
END ColaVacia;
(*--------------------------------------------------------------------*)
PROCEDURE MeterCola(VAR c: TipoCola; paciente: TPaciente; VAR error: ERROR);
VAR
  aux, aux2: TipoCola;
BEGIN
    error:= SinError;
    IF NOT Available(SIZE(Nodo)) THEN
      error:= NoMemoria
    ELSE
      NEW(aux2);
      aux2^.pac:= paciente;
      aux2^.sig:= NIL;
      IF c <> NIL THEN
        IF (Gravedad(paciente,c^.pac)=1) THEN
           aux2^.sig:= c;
           c:= aux2;
        ELSE
           aux:= c;
           WHILE (aux^.sig<>NIL) AND (Gravedad(paciente,aux^.sig^.pac)<>1) DO
              aux:= aux^.sig;
           END;
           aux2^.sig:= aux^.sig;
           aux^.sig:= aux2;
        END;
      ELSE
        c:= aux2;
      END;
    END;
END MeterCola;
(*-------------------------------------------------------------*)
PROCEDURE SacarCola(VAR c: TipoCola; VAR paciente: TPaciente;
					 VAR error: ERROR);
VAR
  NodoABorrar : TipoCola;
BEGIN
    IF c=NIL THEN
       error:= Vacia;
    ELSE
       NodoABorrar:= c;
       c:= c^.sig;
       paciente:= NodoABorrar^.pac;
       DISPOSE(NodoABorrar);
       error:= SinError;
    END;
END SacarCola;
(*------------------------------------------------------------*)
PROCEDURE DestruirCola(VAR c: TipoCola; VAR error: ERROR);
VAR
  NodoABorrar: TipoCola;
BEGIN
    WHILE c<>NIL DO
          NodoABorrar:= c;
          c:= c^.sig;
          DISPOSE(NodoABorrar);
    END;
END DestruirCola;
END Cola.