(*---------- ISRAEL LOZANO REY        1 B - SISTEMAS -----------*)
MODULE Hospital;
FROM IO IMPORT WrStr, RdLn, WrLn, RdChar, RdKey;
FROM Lib IMPORT Delay;
FROM Window IMPORT Clear, TextColor, LightMagenta, GotoXY, White;
FROM cadenas IMPORT Pausa;
FROM paciente IMPORT TPaciente, LeerPaciente, EscribePaciente;
FROM Cola IMPORT TipoCola, ERROR, DestruirCola, MeterCola, SacarCola,
                           CrearCola, ColaVacia;
VAR
  salida   : BOOLEAN;
  opc      : CHAR;
  error    : ERROR;
  cola     : TipoCola;
  paciente : TPaciente;
(*******************************************************)
(*******************************************************)
PROCEDURE Inicio;
BEGIN
    TextColor(LightMagenta);
    GotoXY(22,9);
    WrStr("Programa de gestin de hospitales");
    GotoXY(23,11);
    WrStr("Realizado por Israel Lozano Rey");
    TextColor(White);
    GotoXY(32,15);
    WrStr("Cargando....");
    Delay(3000);
END Inicio;
(*-----------------------------------------------------*)
PROCEDURE Menu(VAR c: CHAR);
BEGIN
    Clear;
    WrStr(" a) Introducir un nuevo paciente."); WrLn;
    WrStr(" b) Mostrar todos los pacientes."); WrLn;
    WrStr(" c) Obtener el paciente siguiente."); WrLn;
    WrStr(" d) Salir."); WrLn;
    REPEAT
         c:= CAP(RdChar());
    UNTIL (c>='A') AND (c<='D');
END Menu;
(*-------------------------------------------------------*)
PROCEDURE Salir(VAR s: BOOLEAN);
VAR
  c : CHAR;
BEGIN
    Clear; WrStr("Desea salir (S/N)?");
    REPEAT
         c:= CAP(RdChar());
    UNTIL (c='S') OR (c='N');
    IF c='S' THEN
       s:= TRUE;
    END;
END Salir;
(*-------------------------------------------------------*)
PROCEDURE NuevoPaciente(VAR cola: TipoCola;VAR error: ERROR);
VAR
  p : TPaciente;
BEGIN
    p:= LeerPaciente();
    MeterCola(cola,p,error);
END NuevoPaciente;
(*-------------------------------------------------------*)
PROCEDURE EvaluaError(error: ERROR;VAR salida:BOOLEAN);
VAR
  c: CHAR;
BEGIN
  CASE error OF
      NoMemoria : WrStr("No hay suficiente memoria, desea abandonar el programa? (S/N) ");
                  REPEAT
                       c:= CAP(RdChar());
                  UNTIL (c='S') OR (c='N');
                  IF c='S' THEN
                      salida:= TRUE;
                  END;|
      Vacia     : WrStr("La cola estaba vaca, Se acabaron las listas de espera!!");
                  WrLn; Pausa; WrLn;
  ELSE
  END;
END EvaluaError;
(*--------------------------------------------------------------*)
PROCEDURE MostrarPacientes(cola: TipoCola;VAR error:ERROR);
VAR
  aux : TipoCola;
  p : TPaciente;
BEGIN
    IF NOT(ColaVacia(cola,error)) THEN
        CrearCola(aux,error);
        WHILE NOT(ColaVacia(cola,error)) DO
              SacarCola(cola,p,error);
              MeterCola(aux,p,error);
              EscribePaciente(p);
        END;
        WHILE NOT(ColaVacia(aux,error)) DO
              SacarCola(aux,p,error);
              MeterCola(cola,p,error);
        END;
        DestruirCola(aux,error);
    ELSE
       WrStr("No hay ningn paciente en lista de espera.");
       WrLn;

    END;
END MostrarPacientes;
(*--------------------------------------------------------------*)
PROCEDURE NextPaciente(VAR cola: TipoCola;VAR p: TPaciente;VAR e: ERROR);
BEGIN
    IF ColaVacia(cola,e) THEN
       WrStr("La cola esta vaca, no hay pacientes en espera.");
       WrLn; Pausa;
       e:= Vacia;
    ELSE
       SacarCola(cola,p,e);
    END;
END NextPaciente;
(*--------------------------------------------------------------*)
BEGIN
    Inicio;
    salida:= FALSE;
    CrearCola(cola,error);
    REPEAT
         Menu(opc);
         CASE opc OF
              'A': NuevoPaciente(cola,error);
                   EvaluaError(error,salida);|
              'B': MostrarPacientes(cola,error);
                   EvaluaError(error,salida);|
              'C': NextPaciente(cola,paciente,error);
                   IF error<>Vacia THEN
                      EscribePaciente(paciente);
                   END; |
              'D': Salir(salida);
         END;
    UNTIL salida;
    DestruirCola(cola,error);
END Hospital.